// Drum Machine by Mark Andrus Roberts
// 4 patterns
// 4 samples
//
// crude system for loading samples write now,
// place sample_1.wav ... sample_4.wav in module directory
// ex. /usr/lib/drum_machine/sample_1.wav
// (i'm sure this is not a good way to do this)
//
//
// 44100 16 bit 1 chan raw audio
// 
#include <errno.h>
#include <string.h>
#include <math.h>
#include <stdio.h>
#include "pz.h"

// random shit from the dialer module.
// --~~i don't really know
#ifndef __linux__
#define pz_dsp_st int
#endif
#ifdef __linux__
static pz_dsp_st dm_dspz;
#else
static int dm_dspz;
#endif

static PzModule *module;

// musical things
#define STEPS 32
int bpm = 120;
float ms_16th = 0;
int nsamps = 44100;
int frame_size = 0;

short * sample_1;
short * sample_2;
short * sample_3;
short * sample_4;
int sample_patterns[4][4][STEPS]; // p, s, pos
int sample = 0;
int pattern = 0; // index of current pattern
int step_pos = 0; // position of cursor
int step_play_pos = 0; // position to be played

// interface variables
int middle_pressed = 0;
int menu_visible = 0;
int grid_width = 0;

// prototypes i guess.
void cleanup_drum_machine();
PzWindow *new_drum_machine_window();
int event_drum_machine(PzEvent *ev);
void draw_drum_machine(PzWidget *wid, ttk_surface surf);
int event_pattern_player (PzEvent *ev);
void dm_play(pz_dsp_st *dspz, int s1, int s2, int s3, int s4);
void load_samples();
void zero_patterns();

// lets get down to it, then

void init_drum_machine()
{
	ms_16th = ((60000.0 / (float) bpm) / 4.0);
	grid_width = STEPS / 4;
	load_samples();
	zero_patterns();
	module = pz_register_module ("drum_machine", cleanup_drum_machine);
	pz_menu_add_action ("/Extras/Stuff/Drum Machine", new_drum_machine_window);
}

void load_samples() {
	int i, j;
	int h = 0;
	int ontime = (60000.0 / bpm) / 4.0;
	nsamps = ontime * (44100 / 1000);
	sample_1 = (short *) malloc (sizeof (short) * nsamps);
	sample_2 = (short *) malloc (sizeof (short) * nsamps);
	sample_3 = (short *) malloc (sizeof (short) * nsamps);
	sample_4 = (short *) malloc (sizeof (short) * nsamps);
	for (i = 0; i < nsamps; i++) {
		sample_1[i] = 0;
		sample_2[i] = 0;
		sample_3[i] = 0;
		sample_4[i] = 0;
	}
	FILE * fin;
	fin = fopen("/usr/lib/drum_machine/sample_1.wav", "r");
	//fin = fopen("/home/mark/Projects/ipodlinux/podzilla2/modules/drum_machine/sample_1.wav", "r");
	fread(sample_1, sizeof (short), nsamps, fin);
	fclose(fin);
	fin = fopen("/usr/lib/drum_machine/sample_2.wav", "r");
	//fin = fopen("/home/mark/Projects/ipodlinux/podzilla2/modules/drum_machine/sample_2.wav", "r");
	fread(sample_2, sizeof (short), nsamps, fin);
	fclose(fin);
	fin = fopen("/usr/lib/drum_machine/sample_3.wav", "r");
	//fin = fopen("/home/mark/Projects/ipodlinux/podzilla2/modules/drum_machine/sample_3.wav", "r");
	fread(sample_3, sizeof (short), nsamps, fin);
	fclose(fin);
	fin = fopen("/usr/lib/drum_machine/sample_4.wav", "r");
	//fin = fopen("/home/mark/Projects/ipodlinux/podzilla2/modules/drum_machine/sample_4.wav", "r");
	fread(sample_4, sizeof (short), nsamps, fin);
	fclose(fin);
}

void zero_patterns() {
	int i, j;
	int h = 0;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 4; j++) {
			for (h = 0; h < STEPS; h++) {
				sample_patterns[i][j][h] = 0;
			}
		}
	}
}

void cleanup_drum_machine()
{
	// dunno what i need to do...
}


// dialer module ripoff
void dm_play(pz_dsp_st *dspz, int s1, int s2, int s3, int s4) {
	short * buffer;
	buffer = (short *) malloc (sizeof (short) * nsamps);
	int j;
	int h = 0;
	for (j = 0; j < nsamps; j++) {
		buffer[j] = (s1 * sample_1[h]) + (s2 * sample_2[h]) + (s3 * sample_3[h]) + (s4 * sample_4[h]);
		buffer[j] = buffer[j] >> 2; // really I don't know if this is necessary or if it even makes sense
		h++;
		if (h >=  nsamps) {
			h = 0;
		}
	}
#ifdef __linux__
	pz_dsp_write (dspz, buffer, nsamps*sizeof(short));
#endif
	free (buffer);
}

PzWindow *new_drum_machine_window()
{
	int dsp_return = 0;
#ifdef __linux__
	dsp_return = pz_dsp_open(&dm_dspz, PZ_DSP_LINEOUT);
#endif
	if (dsp_return < 0) {
		pz_perror("/dev/dsp");
		return;
	}
#ifdef __linux__
	dsp_return = pz_dsp_setup(&dm_dspz, 1, 44100);
#endif

	PzWindow *ret;
	ret = pz_new_window ("Drum Machine", PZ_WINDOW_FULLSCREEN);

	pz_widget_set_timer (pz_add_widget (ret, draw_drum_machine, event_pattern_player), ms_16th);
	pz_add_widget (ret, draw_drum_machine, event_drum_machine);
	
	return pz_finish_window (ret);
}

int event_pattern_player (PzEvent *ev) {
	step_play_pos++;
	if (step_play_pos >= STEPS) {
		step_play_pos = 0;
	}
	int s1 = sample_patterns[pattern][0][step_play_pos];
	int s2 = sample_patterns[pattern][1][step_play_pos];
	int s3 = sample_patterns[pattern][2][step_play_pos];
	int s4 = sample_patterns[pattern][3][step_play_pos];
	if (s1 + s2 + s3 + s4 > 0) { // does this save time? probably
		dm_play (&dm_dspz, s1, s2, s3, s4);
	}
	ev->wid->dirty = 1; // redraw
	return 0;
}

int event_drum_machine (PzEvent *ev) {
	switch (ev->type) {
		case PZ_EVENT_BUTTON_DOWN:
			switch (ev->arg) {
				case PZ_BUTTON_ACTION:
					if (middle_pressed != 1) {
						middle_pressed = 1;
					}
					break;
				case PZ_BUTTON_NEXT:
				case PZ_BUTTON_PREVIOUS:
				case PZ_BUTTON_MENU:
				case PZ_BUTTON_PLAY:
					// i thought maybe i needed
					// something here.
				break;
			}
			break;
		case PZ_EVENT_BUTTON_UP:
			switch (ev->arg) {
				case PZ_BUTTON_NEXT:
					if (!middle_pressed) {
						step_pos += 1;
						if ((step_pos % grid_width) < ((step_pos - 1) % grid_width)) {
							step_pos -= grid_width;
						}
					} else {
						pattern++;
						if (pattern > 3) {
							pattern = 0;
						}
					}
					break;
				case PZ_BUTTON_PREVIOUS:
					if (!middle_pressed) {
						if (step_pos != 0) {
							step_pos -= 1;
							if ((step_pos % grid_width) > (step_pos + 1) % grid_width) {
								step_pos += grid_width;
							}
						} else {
							step_pos = grid_width - 1;
						}
					} else {
						pattern--;
						if (pattern < 0) {
							pattern = 3;
						}
					}
					break;
				case PZ_BUTTON_MENU:
					if (!middle_pressed) {
						if (step_pos - grid_width >= 0) {
							step_pos -= grid_width;
						} else {
							step_pos += STEPS - grid_width;
						}
					} else {
						sample++;
						if (sample == 4) {
							sample = 0;
						}
					}
					break;
				case PZ_BUTTON_PLAY:
					if (!middle_pressed) {
						step_pos += grid_width;
						if (step_pos >= STEPS) {
							step_pos -= STEPS;
						}
					} else {
						sample--;
						if (sample < 0) {
							sample = 3;
						}
					}
					break;
				case PZ_BUTTON_ACTION:
					if (ev->time < 1000) {
						sample_patterns[pattern][sample][step_pos] = abs(sample_patterns[pattern][sample][step_pos] - 1);
					}
					middle_pressed = 0;
					break;
				case PZ_BUTTON_HOLD:
					pz_close_window (ev->wid->win);
					break;
			}
			ev->wid->dirty = 1; // redraw
			break;
		case PZ_EVENT_DESTROY:
			free (sample_1);
			free (sample_2);
			free (sample_3);
			free (sample_4);
#ifdef __linux__
			pz_dsp_close (&dm_dspz);
#endif
			break;
	}
	return 0;
}

void draw_drum_machine (PzWidget *wid, ttk_surface srf) 
{
	// draw textual things - would this be better if i just did a header?
	// must look into this...
	ttk_fillrect (srf, 0, 0, wid->w, wid->h, ttk_makecol (WHITE));
	int x = wid->h * 0.01;
	int y = x;
	ttk_font fnt = ttk_get_font("", 12); // whats a groovy font?
	switch (pattern) { // i fuck up with making strings in c so i did it this way.
		case 0:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "P1 ");
			break;
		case 1:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "P2 ");
			break;
		case 2:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "P3 ");
			break;
		case 3:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "P4 ");
			break;
	}
	x += ttk_text_width (fnt, "XXX");
	switch (sample) {
		case 0:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "S1 ");
			break;
		case 1:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "S2 ");
			break;
		case 2:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "S3 ");
			break;
		case 3:
			ttk_text (srf, fnt, x, y, ttk_makecol (BLACK), "S4 ");
			break;
	}
	char text[3];
	sprintf (text, "%i", bpm);
	ttk_text (srf, fnt, x + 2 * ttk_text_width (fnt, "XXX"), y, ttk_makecol (BLACK), text);

	// now the drum machine grid view
	x = 0;
	y = 0;
	int h_incr = (wid->w * 0.9) / grid_width;
	int v_incr = (wid->h * 0.9) / (STEPS / grid_width);
	if (h_incr < v_incr) {
		v_incr = h_incr;
	} else {
		h_incr = v_incr;
	}
	int h_margin = ((wid->w * 0.1)); // / 2.0); // + ((h_incr * 0.1) / 2.0);
	int v_margin = ((wid->h * 0.1)); // / 2.0); // + ((v_incr * 0.1) / 2.0);
	//int v_margin = (wid->h - (wid->w * 0.5)) / 2.0;
	int i, j;
	for (i = 0; i < grid_width; i++) {
		for (j = 0; j < (STEPS / grid_width); j++) {
			int select = (j * grid_width) + i;
			int x = h_margin + (i * h_incr);
			int y = v_margin + (j * v_incr);
			ttk_rect (srf, x, y, x + (h_incr * 0.9), y + (v_incr * 0.9), ttk_makecol (BLACK));
			if (sample_patterns[pattern][sample][select] == 1) { // fill black samples which are toggled on
				ttk_fillrect (srf, x, y, x + (h_incr * 0.9), y + (v_incr * 0.9), ttk_makecol (BLACK));
			}
			if (step_play_pos == select) { // draw step_play_pos flash thing
				ttk_fillrect (srf, x, y, x + (h_incr * 0.9), y + (v_incr * 0.9), ttk_makecol (WHITE));
			}
		}
	}
	if (step_pos != -1) { // draw cursor
		int i = step_pos % (grid_width);
		int j = step_pos / (grid_width);
		int x = h_margin + (i * h_incr);
		int y = v_margin + (j * v_incr);
		int mx = (h_incr * 0.5) / 2.0; 
		int my = (v_incr * 0.5) / 2.0;
		int x2 = x + (h_incr * 0.9) - mx;
		int y2 = y + (v_incr * 0.9) - my;
		x += mx;
		y += my;
		ttk_fillrect (srf, x, y, x2, y2, ttk_makecol (WHITE));
		ttk_rect (srf, x, y, x2, y2, ttk_makecol (BLACK));
	}
}

PZ_MOD_INIT(init_drum_machine) /* No semicolon at end of line. Should probably be the *last* line in file. */
